<html>
<head>
<title>OgreGLESPrerequisites.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_9e680f2cca56003d76c91ad8153c6d1e.html">GLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_2b7861191a86db021136edf07f6d3897.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLESPrerequisites.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLESPrerequisites_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2008 Renato Araujo Oliveira Filho &lt;renatox@gmail.com&gt;</span>
<a name="l00008"></a>00008 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00011"></a>00011 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00012"></a>00012 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00013"></a>00013 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00014"></a>00014 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00015"></a>00015 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00016"></a>00016 <span class="comment"></span>
<a name="l00017"></a>00017 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00018"></a>00018 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00021"></a>00021 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00022"></a>00022 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00023"></a>00023 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00024"></a>00024 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00025"></a>00025 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00026"></a>00026 <span class="comment">THE SOFTWARE.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __GLESPrerequisites_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __GLESPrerequisites_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMath_8h.html">OgreMath.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#if (OGRE_PLATFORM == OGRE_PLATFORM_SYMBIAN)</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#   undef _WIN32</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="preprocessor">#if (OGRE_PLATFORM == OGRE_PLATFORM_WIN32)</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#   if !defined( __MINGW32__ )</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#       ifndef WIN32_LEAN_AND_MEAN</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#           define WIN32_LEAN_AND_MEAN 1</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#       ifndef NOMINMAX</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span><span class="preprocessor">#           define NOMINMAX // required to stop windows.h messing up std::min</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="preprocessor">#if (OGRE_PLATFORM == OGRE_PLATFORM_APPLE_IOS)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#   include &lt;OpenGLES/ES1/gl.h&gt;</span>
<a name="l00053"></a>00053 <span class="preprocessor">#   include &lt;OpenGLES/ES1/glext.h&gt;</span>
<a name="l00054"></a>00054 <span class="preprocessor">#   ifdef __OBJC__</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#       include &lt;OpenGLES/EAGL.h&gt;</span>
<a name="l00056"></a>00056 <span class="preprocessor">#   endif</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#   ifndef GL_GLEXT_PROTOTYPES</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#       define  GL_GLEXT_PROTOTYPES</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">#   include &lt;GLES/gl.h&gt;</span>
<a name="l00062"></a>00062 <span class="preprocessor">#   include &lt;GLES/glext.h&gt;</span>
<a name="l00063"></a>00063 <span class="preprocessor">#   include &lt;GLES/egl.h&gt;</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">// If we are going to use the PVRTC_CODEC make sure we</span>
<a name="l00066"></a>00066 <span class="comment">// setup the needed constants</span>
<a name="l00067"></a>00067 <span class="preprocessor">#if (OGRE_NO_PVRTC_CODEC == 0)</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span><span class="preprocessor">#   ifndef GL_IMG_texture_compression_pvrtc</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span><span class="preprocessor">#       define GL_IMG_texture_compression_pvrtc 1</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#       define GL_COMPRESSED_RGB_PVRTC_4BPPV1_IMG                      0x8C00</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#       define GL_COMPRESSED_RGB_PVRTC_2BPPV1_IMG                      0x8C01</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span><span class="preprocessor">#       define GL_COMPRESSED_RGBA_PVRTC_4BPPV1_IMG                     0x8C02</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="preprocessor">#       define GL_COMPRESSED_RGBA_PVRTC_2BPPV1_IMG                     0x8C03</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00077"></a>00077 <span class="comment">// Function pointers for FBO extension methods</span>
<a name="l00078"></a>00078 <span class="comment">// Declare them here since we don&#39;t have GLEW to do it for us</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#   ifndef GL_GLEXT_PROTOTYPES</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span><span class="keyword">extern</span> PFNGLISRENDERBUFFEROESPROC glIsRenderbufferOES;
<a name="l00082"></a>00082 <span class="keyword">extern</span> PFNGLBINDRENDERBUFFEROESPROC glBindRenderbufferOES;
<a name="l00083"></a>00083 <span class="keyword">extern</span> PFNGLDELETERENDERBUFFERSOESPROC glDeleteRenderbuffersOES;
<a name="l00084"></a>00084 <span class="keyword">extern</span> PFNGLGENRENDERBUFFERSOESPROC glGenRenderbuffersOES;
<a name="l00085"></a>00085 <span class="keyword">extern</span> PFNGLRENDERBUFFERSTORAGEOESPROC glRenderbufferStorageOES;
<a name="l00086"></a>00086 <span class="keyword">extern</span> PFNGLGETRENDERBUFFERPARAMETERIVOESPROC glGetRenderbufferParameterivOES;
<a name="l00087"></a>00087 <span class="keyword">extern</span> PFNGLISFRAMEBUFFEROESPROC glIsFramebufferOES;
<a name="l00088"></a>00088 <span class="keyword">extern</span> PFNGLBINDFRAMEBUFFEROESPROC glBindFramebufferOES;
<a name="l00089"></a>00089 <span class="keyword">extern</span> PFNGLDELETEFRAMEBUFFERSOESPROC glDeleteFramebuffersOES;
<a name="l00090"></a>00090 <span class="keyword">extern</span> PFNGLGENFRAMEBUFFERSOESPROC glGenFramebuffersOES;
<a name="l00091"></a>00091 <span class="keyword">extern</span> PFNGLCHECKFRAMEBUFFERSTATUSOESPROC glCheckFramebufferStatusOES;
<a name="l00092"></a>00092 <span class="keyword">extern</span> PFNGLFRAMEBUFFERRENDERBUFFEROESPROC glFramebufferRenderbufferOES;
<a name="l00093"></a>00093 <span class="keyword">extern</span> PFNGLFRAMEBUFFERTEXTURE2DOESPROC glFramebufferTexture2DOES;
<a name="l00094"></a>00094 <span class="keyword">extern</span> PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIVOESPROC glGetFramebufferAttachmentParameterivOES;
<a name="l00095"></a>00095 <span class="keyword">extern</span> PFNGLGENERATEMIPMAPOESPROC glGenerateMipmapOES;
<a name="l00096"></a>00096 <span class="keyword">extern</span> PFNGLBLENDEQUATIONOESPROC glBlendEquationOES;
<a name="l00097"></a>00097 <span class="keyword">extern</span> PFNGLBLENDFUNCSEPARATEOESPROC glBlendFuncSeparateOES;
<a name="l00098"></a>00098 <span class="keyword">extern</span> PFNGLBLENDEQUATIONSEPARATEOESPROC glBlendEquationSeparateOES;
<a name="l00099"></a>00099 <span class="keyword">extern</span> PFNGLMAPBUFFEROESPROC glMapBufferOES;
<a name="l00100"></a>00100 <span class="keyword">extern</span> PFNGLUNMAPBUFFEROESPROC glUnmapBufferOES;
<a name="l00101"></a>00101 <span class="preprocessor">#   endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>
<a name="l00103"></a>00103 <span class="preprocessor">#endif</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00105"></a>00105 <span class="comment">// Define GL_NONE for convenience</span>
<a name="l00106"></a><a class="code" href="OgreGLESPrerequisites_8h.html#a089a3736e5280b9c7cc50129e2659974">00106</a> <span class="preprocessor">#define GL_NONE 0</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>
<a name="l00108"></a>00108 <span class="preprocessor">#ifndef GL_BGRA</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span><span class="preprocessor">#   define GL_BGRA  0x80E1</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>
<a name="l00112"></a>00112 <span class="preprocessor">#if (OGRE_PLATFORM == OGRE_PLATFORM_WIN32) &amp;&amp; !defined(__MINGW32__) &amp;&amp; !defined(OGRE_STATIC_LIB)</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">#   ifdef OGRE_GLESPLUGIN_EXPORTS</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span><span class="preprocessor">#       define _OgreGLESExport __declspec(dllexport)</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span><span class="preprocessor">#       if defined( __MINGW32__ )</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span><span class="preprocessor">#           define _OgreGLESExport</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span><span class="preprocessor">#       else</span>
<a name="l00119"></a><a class="code" href="OgreGLESPrerequisites_8h.html#aacfbc6e9783463d78a54316f63943b0a">00119</a> <span class="preprocessor"></span><span class="preprocessor">#           define _OgreGLESExport __declspec(dllimport)</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span><span class="preprocessor">#       endif</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span><span class="preprocessor">#elif defined ( OGRE_GCC_VISIBILITY )</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span><span class="preprocessor">#    define _OgreGLESExport  __attribute__ ((visibility(&quot;default&quot;)))</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span><span class="preprocessor">#    define _OgreGLESExport</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00128"></a>00128 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00129"></a><a class="code" href="OgreGLESPrerequisites_8h.html#a9c15fe1e91b07ea3280f5239f9841b67">00129</a> <span class="preprocessor"></span><span class="preprocessor">#define __PRETTY_FUNCTION__ __FUNCTION__</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="OgreGLESPrerequisites_8h.html#a45bbdef2e602a1d12b999a837df8fb89">00133</a> <span class="preprocessor">#define DEBUG_(text) \</span>
<a name="l00134"></a>00134 <span class="preprocessor">    {\</span>
<a name="l00135"></a>00135 <span class="preprocessor">        fprintf(stderr, &quot;%s:%d: %s\n&quot;, __FUNCTION__, __LINE__, text); \</span>
<a name="l00136"></a>00136 <span class="preprocessor">    }</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a><a class="code" href="OgreGLESPrerequisites_8h.html#a73ff6a326ebf3637a67218046668ce64">00138</a> <span class="preprocessor">#define ENABLE_GL_CHECK 0</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span><span class="preprocessor">#if ENABLE_GL_CHECK</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span><span class="preprocessor">#define GL_CHECK_ERROR \</span>
<a name="l00141"></a>00141 <span class="preprocessor">    { \</span>
<a name="l00142"></a>00142 <span class="preprocessor">        int e = glGetError(); \</span>
<a name="l00143"></a>00143 <span class="preprocessor">        if (e != 0) \</span>
<a name="l00144"></a>00144 <span class="preprocessor">        { \</span>
<a name="l00145"></a>00145 <span class="preprocessor">            fprintf(stderr, &quot;OpenGL error 0x%04X in %s at line %i in %s\n&quot;, e, __PRETTY_FUNCTION__, __LINE__, __FILE__); \</span>
<a name="l00146"></a>00146 <span class="preprocessor">        } \</span>
<a name="l00147"></a>00147 <span class="preprocessor">    }</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00149"></a><a class="code" href="OgreGLESPrerequisites_8h.html#a56aaa83bc346bbef34e231c43cb3b443">00149</a> <span class="preprocessor"></span><span class="preprocessor">    #define GL_CHECK_ERROR {}</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="preprocessor">#if ENABLE_GL_CHECK</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span><span class="preprocessor">    #define EGL_CHECK_ERROR \</span>
<a name="l00155"></a>00155 <span class="preprocessor">    { \</span>
<a name="l00156"></a>00156 <span class="preprocessor">        int e = eglGetError(); \</span>
<a name="l00157"></a>00157 <span class="preprocessor">        if ((e != 0) &amp;&amp; (e != EGL_SUCCESS))\</span>
<a name="l00158"></a>00158 <span class="preprocessor">        { \</span>
<a name="l00159"></a>00159 <span class="preprocessor">            fprintf(stderr, &quot;OpenGL error 0x%04X in %s at line %i in %s\n&quot;, e, __PRETTY_FUNCTION__, __LINE__, __FILE__); \</span>
<a name="l00160"></a>00160 <span class="preprocessor">            assert(false); \</span>
<a name="l00161"></a>00161 <span class="preprocessor">        } \</span>
<a name="l00162"></a>00162 <span class="preprocessor">    }</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00164"></a><a class="code" href="OgreGLESPrerequisites_8h.html#a970bd7d687d827541d8b0d765d808048">00164</a> <span class="preprocessor"></span><span class="preprocessor">    #define EGL_CHECK_ERROR {}</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
